
;**********************************************************************

	list      p=12F683        ; list directive to define processor
	#include <P12F683.inc>    ; processor specific variable definitions

	errorlevel  -302          ; suppress message 302 from list file

	__CONFIG   _FCMEN_ON & _IESO_OFF & _CP_OFF & _CPD_OFF & _BOD_OFF & _MCLRE_OFF & _WDT_OFF & _PWRTE_OFF & _INTRC_OSC_NOCLKOUT 

; '__CONFIG' directive is used to embed configuration word within .asm file.



;***** VARIABLE DEFINITIONS
w_temp        EQU     0x70        ; variable used for context saving 
status_temp   EQU     0x71        ; variable used for context saving
w	equ 0
f	equ 1

;;;;;;;;;;;
      cblock  20H
 
	Reg_1	  	
	Reg_2
	Reg_3
	FLAG        
	                             ; 0-
	                             ; 1-    
	                             ; 2-    
	                             ; 3-    
                                  ;      
                                  ; 5-  ,    ,
                                   ;    (-20 - 34,3)
                                   ; 4-  
                                   ; 7 - "1" -  ,   "Ӫ" 
                                   ;  

	TimeVym                    ; -    ( 
                               ;   1,   0,524288  
                               ;  
	TimeHV                     ; -      
                               ;    
	LimVym            ;0x1D=(29+1)x0,524288=15,73 -  
	DibBat            ;     "" 
	DibBatDES         ;    ,     
	DibBatOD         ;    ,     
	LIM1               ;     
	LIM2               ;     
	IMPHV              ; 10 

	VymOD             ; ,    
	VymDES            ;   =   
	VymOD_temp             ; ,    
	VymDES_temp            ;   =   	

	SLR1                       ;  
	SLR2	                       ;
	SLR3	

	SLR5
	SLR7
	SLR8
	SLR9
	LICH                       ;  

	Zn1               ;   
	Zn2               ; -/-    
	Zn3               ;-/-  -/-    1 
                   ;   -20  2535   = 131315
                    ; (      253534,08() = 86392,  86400=)
	LichDOB1        ; , -  (  )
	LichDOB2         ; 
	LichDOB3
	endc



;**********************************************************************
	ORG     0x000             ; processor reset vector
	goto    main              ; go to beginning of program
	

Podija	ORG     0x004             ;  Ѳ 
	movwf   w_temp            ; save off current W register contents
	movf	STATUS,w          ; move status register into W register
	movwf	status_temp       ; save off contents of STATUS register

	
; isr code can go here or be located as a call subroutine elsewhere

	BTFSC  INTCON,GPIF     ;      
	GOTO   Vh_Imp

	BTFSC PIR1,TMR1IF   ;   1
	GOTO Chas_Vym	

	GOTO Podija_End

Vh_Imp                      ;       

	BTFSS   GPIO,4
	CALL DELAY_005 ;     
	BTFSS   GPIO,4
	CALL INDVYM

	BTFSC	INTCON,GPIF	
	CALL IMPULS
	BCF INTCON,GPIF	
	GOTO Podija_End

Chas_Vym                   ;    1
	CALL TIMER1          ;
	BCF PIR1,TMR1IF        ;
	GOTO Podija_End

Podija_End
	movf    status_temp,w     ; retrieve copy of STATUS register
	movwf	STATUS            ; restore pre-isr STATUS register contents
	swapf   w_temp,f
	swapf   w_temp,w          ; restore pre-isr W register contents

	retfie                    ; return from interrupt
;****************************************************************************************
main
	bsf	       STATUS, RP0	 ;   1
	clrf      ANSEL
	CLRF TRISIO
	MOVLW        b'00011000'; GP4,GP3  
	MOVWF      TRISIO

 	MOVLW     b'00000000'  ;1-    , 0 -  (7-	, 
	MOVWF OPTION_REG       ;  )

	MOVLW     b'00010000'  ;    GP4
	MOVWF WPU       ;

	MOVLW        b'11001000'   ;11001000 - , (1),GPIO change (GP3   IOC)
	movwf	INTCON             ;

	MOVLW        b'00011000'
	movwf	IOC                     ;    GP4(pin3)-, GP3(pin4)-.
	
	MOVLW  b'00000001'   ;    1
	movwf PIE1

	bCf	       STATUS, RP0   ;   0
 	movlw  07h         ;  
	movwf   CMCON0      ;   

	MOVLW   b'00110001'  ; 1 + 11=1:8, 1 
	movwf   T1CON       ;       Fosc/4

	CLRW        ;   0-  EEPROM
	CALL READ_MEM   ; 0xXX=(XX+1)x2=.. -  
	MOVWF LimVym    ;


	movlw .1        ;   1-  EEPROM
	CALL READ_MEM   ; 
	MOVWF DibBat    ;     "" 

	movlw .2        ;   2-  EEPROM
	CALL READ_MEM   ;   50/ = 032
	MOVWF LIM1    ; 

	movlw .3        ;   3-  EEPROM
	CALL READ_MEM   ;   75/ = 04B
	MOVWF LIM2    ; 

	movlw .4        ;   4-  EEPROM
	CALL READ_MEM   ; 0xXX=(XX*3+5)=...() -    
	MOVWF IMPHV    ;     002---> 400

	movlw .5        ;   5-  EEPROM
	CALL READ_MEM   ;    
	MOVWF Zn1    ;      1 

	movlw .6        ;   6-  EEPROM
	CALL READ_MEM   ;    
	MOVWF Zn2    ;      1 

	movlw .7        ;   7-  EEPROM
	CALL READ_MEM   ;    
	MOVWF Zn3    ;      1 

	;    -
	; 131315 = 2535   34,3 = 86400 = 1 

	CLRF   TMR1L
	CLRF   TMR1H
	CLRF	GPIO 
	CLRF LICH
	clrf FLAG
	CLRF TimeVym
	CLRF TimeHV
	CLRF VymDES_temp
	CLRF VymOD_temp
	CLRF VymDES
	CLRF VymOD
; remaining code goes here



; initialize eeprom locations

;	ORG	0x2100
;	DE	0x00, 0x01, 0x02, 0x03




;	CALL BatDES_OD  ;         
                      ;        
          ;    DibBatDES     ,     
          ;	DibBatOD     ,     

	MOVF Zn1,w          ;         
	MOVWF LichDOB1       ;131315 = 2535 =  1 (  
	MOVF Zn2,w          ;   -20,  34,3  2535)
	MOVWF LichDOB2      ;
	MOVF Zn3,w          ;
	MOVWF LichDOB3      ;


CYCLE
                      ;    

	BSF      GPIO,0         ;       
	CALL    IMP       ;            , ! ! ! ²Ĳ   ! ! !
	BCF      GPIO,0         ;   400   	IMPHV  =003
	CALL    Zatr250mks   ;


	BTFSS FLAG,5 ;    ,   
	BSF   GPIO,5  ;    .

                      ;    
     goto      CYCLE 

;;;;;;;;;;;;;ϲ;;;;;;;;;;;;;;;;;

;-------------------------------------------------------------------------------
IMPULS

	CALL  Zatr100mks    ;   100,   
                        ;  -20  250
 
    btfsc     GPIO, 3    ;  ,   -       
     goto      zavada                     

	INCF VymOD_temp,f
	MOVLW   D'10'
	SUBWF VymOD_temp,w
	BTFSS   STATUS,Z
	GOTO    prodov
	CLRF   VymOD_temp
	INCF   VymDES_temp,f
prodov
	INCF     LICH,1   ;      
	MOVF     LICH,0   ;    ""
	
	btfsc FLAG,1      ;
	GOTO porig2

	SUBWF    LIM1,0       ;       LIM1 
	BTFSS STATUS,C      ;      '  
	goto PEREVYSHCH1   ;     
	GOTO kin

porig2


	MOVF     LICH,0   ;    ""
	SUBWF    LIM2,0     ;      LIM2 
	BTFSS STATUS,C      ;     ""
	goto PEREVYSHCH2   ;     


kin
	btfsc FLAG,1      ;       1-     
	GOTO pic     ;         

	BTFSC FLAG,3      ;        1- 
	GOTO pic      ;         

	GOTO pryhov
pic
	call PYSHCHYK 
	GOTO zavada

pryhov
	call PYSHCHYK_PRYHOV  ;       
                           ;      
zavada

	RETURN
;---------------------------------------------------------------------------------------
PEREVYSHCH1
	call PYSHCHYK
	BSF FLAG,1    ;     
	BSF FLAG,3   ;     
                  ;     
                  ;    


	RETURN
;---------------------------------------------------------------------------------------
PEREVYSHCH2
	BSF FLAG,2    ;     

	CALL   FIXVYM

	call TRYVOGA
	CALL DELAY_250
	call TRYVOGA
	CALL DELAY_250
	call TRYVOGA
	CALL DELAY_250
	call TRYVOGA
	CALL DELAY_250
	call TRYVOGA
	CALL DELAY_250

	CLRF TMR1H
	CLRF TMR1L
	CLRF LICH


	BSF FLAG,5     ;      
	RETURN

;----------------------------------------------------------------------------------------
TRYVOGA         ;  

	movlw       .013
     movwf       SLR7
zvk
	CALL PYSHCHYK
	decfsz      SLR7,F
     goto        zvk
 
	RETURN
;---------------------------------------------------------------------------------------
KINVYM                           
	CALL FIXVYM
	CLRF TimeVym     ; -  1
	CLRF LICH        ; - 
	CLRF TMR1H
	CLRF TMR1L

	BTFSS FLAG,1     ;         
	BCF	  FLAG,3     ;   3 = 1
	BCF   FLAG,1     ;    1, 
                      ;      
                      ;   1-         
	BSF FLAG,5     ;    (-20 - 34,3)
	RETURN
;------------------------------------------------------------------------------------------
TIMER1     ;      1
           ; ,   Ͳ 0,524288.
           ;     = LimVym x 0,524288 
           ;    =KINVYM= 


		
	INCF     TimeVym,f   ;        
	MOVF     TimeVym,w   ;    ""
	SUBWF    LimVym,w       ;       LimVym 
	BTFSS   STATUS,C      ;     
	CALL    KINVYM             ; - LICH


	RETURN


;--------------------------------------------------------------------------------
PYSHCHYK


	CLRF GPIO

	movlw       .013
     movwf       SLR5
zvtrv3
	BSF GPIO,1
	BCF GPIO,2
	CALL Zatr250mks

	BCF GPIO,1
	BSF GPIO,2
	CALL Zatr250mks

	decfsz      SLR5,F
     goto        zvtrv3
	CLRF GPIO

	movlw       .013
     movwf       SLR5
zvtrv4
	BSF GPIO,1
	BCF GPIO,2
	CALL Zatr250mks
	CALL Zatr100mks
	BCF GPIO,1
	BSF GPIO,2
	CALL Zatr250mks
	CALL Zatr100mks

	decfsz      SLR5,F
     goto        zvtrv4
	CLRF GPIO


	RETURN
;-------------------------------------------------------------------------------
PYSHCHYK_PRYHOV     ;       
                           ;         
	CLRF GPIO

	movlw       .013
     movwf       SLR5
zvtrv1
	BSF GPIO,1
	BSF GPIO,2
	CALL Zatr250mks

	BCF GPIO,1
	BCF GPIO,2
	CALL Zatr250mks

	decfsz      SLR5,F
     goto        zvtrv1
	CLRF GPIO

	movlw       .013
     movwf       SLR5
zvtrv2
	BSF GPIO,1
	BSF GPIO,2
	CALL Zatr250mks
	CALL Zatr100mks
	BCF GPIO,1
	BCF GPIO,2
	CALL Zatr250mks
	CALL Zatr100mks

	decfsz      SLR5,F
     goto        zvtrv2
	CLRF GPIO


	RETURN
;--------------------------------------------------------------------------------
IMP    ; ,        
  		   movf       IMPHV,0
            movwf       SLR9
            decfsz      SLR9,F
            goto        $-1
    return

;---------------------------------------------------------------------------------
INDVYM      ;


	BCF INTCON,GPIF	;


	CALL DELAY_250 ;       0,25, 
	BTFSS   GPIO,4 ;     
	GOTO akb                ;,  .


	BCF   GPIO,5
	CALL DELAY_250
	CALL DELAY_250
	CALL DELAY_250
	CALL DELAY_250

	CLRW              ;            -   
	SUBWF VymDES,w        ;
	BTFSC   STATUS,Z           ;  ="0",  Z="1",  
	GOTO    nulDES         ;    "0",  Z="0"
          
	MOVF VymDES,w          ;
	MOVWF SLR2           ;
des10

	BSF GPIO,5	          ;
	CALL DELAY_250            ;
	CALL DELAY_250          ;
	BCF GPIO,5             ;
	CALL DELAY_250         ;
	CALL DELAY_250         ;
	DECFSZ VymDES,f       ;
                          
	GOTO des10             ;

	CALL DELAY_250         ;                         

	MOVF SLR2,w            ;
	MOVWF VymDES        ;
;	GOTO odyn

nulDES



	CLRW                 ;       -   
	SUBWF VymOD,w         ;    
	BTFSS   STATUS,Z        ;  ="0",  Z="1",  
	GOTO    odyn         ;    "0",  Z="0"
 
 ;  ,   
	CLRW              ;             - " "
	SUBWF VymDES,w        ;     ="0",  Z="1",  
	BTFSC   STATUS,Z           ;     "0",  Z="0"
	GOTO dv             ;      "  " -  " "
	INCF VymOD,f        ;  -    "1",  = 1
                        
odyn
	MOVF VymOD,w         ;
	MOVWF SLR2          ;
                     
odyn1         
      
            
	CALL DELAY_250            ;
	BSF GPIO,5	           ;
	CALL DELAY_250         ;
	BCF GPIO,5            ;
	DECFSZ VymOD,f        ;

	GOTO odyn1              ;

	MOVF SLR2,w          ;
	MOVWF VymOD         ;
	GOTO prod          ;


                        
dv
	BSF GPIO,5	          ;    "    "
	CALL DELAY_250        ;
	BCF GPIO,5           ;
	CALL DELAY_250        ;
	BSF GPIO,5	        ;
	CALL DELAY_250        ;
	CALL DELAY_250         ;
	CALL DELAY_250 
	BCF GPIO,5         ;
	CALL DELAY_250         ;
	BSF GPIO,5	        ;
	CALL DELAY_250       ;
	BCF GPIO,5         ;
	CALL DELAY_250        ;
	BSF GPIO,5	      ;
	CALL DELAY_250         ;
	CALL DELAY_250       ;
	CALL DELAY_250 
	BCF GPIO,5          ;
	CALL DELAY_250       ;
	BSF GPIO,5	        ;
	CALL DELAY_250        ;
	BCF GPIO,5         ;
	CALL DELAY_250       ;
	BSF GPIO,5	        ;
	CALL DELAY_250 
	CALL DELAY_250         ;
	CALL DELAY_250
	BCF GPIO,5           ;
	GOTO prod          ;

akb                     ;    
	CALL BatDES_OD
	BCF   GPIO,1
	BSF   GPIO,2
	CALL DELAY_250   ;   ,   
	BCF   GPIO,2    ;       

	BCF   GPIO,5   ;   ,     
	CALL DELAY_250 ; ,    (GPIO,5)

	BTFSC   FLAG,7
	CALL  BATROZR  ;    ,  
	CALL DELAY_250  ;  "",  == 
                     ;      GPIO,2
	BCF GPIO,5     ;
	CALL DELAY_250
	CALL DELAY_250
;	CALL DELAY_250



	CLRW              ;            -   
	SUBWF DibBatDES,w        ;
	BTFSC   STATUS,Z           ;  ="0",  Z="1",  
	GOTO    nulDES1         ;    "0",  Z="0"
          
	MOVF DibBatDES,w          ;
	MOVWF SLR3           ;
des110

	BSF GPIO,2	          ;
	CALL DELAY_250            ;
	CALL DELAY_250          ;
	BCF GPIO,2             ;
	CALL DELAY_250         ;
	CALL DELAY_250         ;
	DECFSZ DibBatDES,f        ;
                          
	GOTO des110             ;

	CALL DELAY_250         ;                         

	MOVF SLR3,w            ;
	MOVWF DibBatDES         ;
;	GOTO odyn

nulDES1



	CLRW                 ;       -   
	SUBWF DibBatOD,w         ;    
	BTFSS   STATUS,Z        ;  ="0",  Z="1",  
	GOTO    odyn11         ;    "0",  Z="0"
 
 ;  ,   
	CLRW              ;             - " "
	SUBWF DibBatDES,w        ;     ="0",  Z="1",  
	BTFSC   STATUS,Z           ;     "0",  Z="0"
	GOTO dv1             ;      "  " -  " "
	INCF DibBatOD,f        ;  -    "1",  = 1
                        
odyn11
	MOVF DibBatOD,w         ;
	MOVWF SLR3          ;
                     
odyn12         
      
            
	CALL DELAY_250            ;
	BSF GPIO,2	           ;
	CALL DELAY_250         ;
	BCF GPIO,2            ;
	DECFSZ DibBatOD,f        ;

	GOTO odyn12              ;

	MOVF SLR2,w          ;
	MOVWF DibBatOD         ;
	GOTO prod          ;

dv1
	BSF GPIO,2	          ;    "    "
	CALL DELAY_250        ;
	BCF GPIO,2           ;
	CALL DELAY_250        ;
	BSF GPIO,2	        ;
	CALL DELAY_250        ;
	CALL DELAY_250         ;
	CALL DELAY_250 
	BCF GPIO,2         ;
	CALL DELAY_250         ;
	BSF GPIO,2	        ;
	CALL DELAY_250       ;
	BCF GPIO,2         ;
	CALL DELAY_250        ;
	BSF GPIO,2	      ;
	CALL DELAY_250         ;
	CALL DELAY_250       ;
	CALL DELAY_250 
	BCF GPIO,2          ;
	CALL DELAY_250       ;
	BSF GPIO,2	        ;
	CALL DELAY_250        ;
	BCF GPIO,2         ;
	CALL DELAY_250       ;
	BSF GPIO,2	        ;
	CALL DELAY_250 
	CALL DELAY_250         ;
	CALL DELAY_250
	BCF GPIO,2           ;
	GOTO prod          ;




	
prod

	CALL DELAY_250
	CALL DELAY_250
	CALL DELAY_250
	CALL DELAY_250


	CLRF TimeVym     ; -  1
	CLRF LICH        ; - 
	CLRF TMR1H
	CLRF TMR1L
	BCF INTCON,GPIF	;      -   GPIF
	CLRF VymDES_temp
	CLRF VymOD_temp
	BCF FLAG,5      ;    
	RETURN

;---------------------------------------------------------------------------------
FIXVYM
	MOVF VymOD_temp,w
	MOVWF VymOD
	MOVF VymDES_temp,w
	MOVWF VymDES
	CLRF VymOD_temp
	CLRF VymDES_temp
	BCF   GPIO,5
                        ; ,    ,
                        ;    Zn1,Zn2,Zn3 (EEPROM)
                        ;LichDOB1, LichDOB2, LichDOB3 -  
	DECFSZ LichDOB1,f   ;
	GOTO vyhid
	DECFSZ  LichDOB2,f   ;
	GOTO vyhid1
	DECFSZ  LichDOB3,f   ;
	GOTO vyhid2
                          ; ,    
	CALL DOBA
	GOTO vyhid

vyhid1                    ; ,  1-  ,  2- - 
	MOVF   Zn1,w
	MOVWF  LichDOB1
	GOTO vyhid

vyhid2                    ; ,  1-  2-  ,  3- - 
	MOVF   Zn1,w
	MOVWF  LichDOB1
	MOVF   Zn2,w
	MOVWF  LichDOB2

vyhid
	RETURN

;---------------------------------------------------------------------------------
DOBA           ;   LichDOB1, LichDOB2
	MOVF   Zn1,w
	MOVWF  LichDOB1
	MOVF   Zn2,w
	MOVWF  LichDOB2
	MOVF Zn3,w
	MOVWF LichDOB3	

	BTFSS FLAG,7   ;1 -    
	CALL  BatOK     ;
	BTFSC FLAG,7    ; 0 -      (  )
	CALL  BatBAD    ;
	RETURN	
;---------------------------------------------------------------------------------
BatOK             ;       (  )
	DECFSZ   DibBat,f
	GOTO zav
	CALL BatBAD     ;     -  ""

zav
	RETURN
;---------------------------------------------------------------------------------
BatBAD           ;      
	BSF   FLAG,7   ;     "" 
	INCF DibBat,f ;        

	RETURN
;---------------------------------------------------------------------------------
BatDES_OD   ;         
;        
;    DibBatDES         ;    ,     
;	DibBatOD         ;    ,     
	CLRF DibBatOD
	CLRF DibBatDES
	MOVF DibBat,w
	MOVWF SLR8
perev

	INCF DibBatOD,f
	MOVLW D'10'   ;  10
	SUBWF DibBatOD,w
	BTFSS STATUS,Z
	GOTO ok
	CLRF DibBatOD
	INCF DibBatDES,f

ok
	DECFSZ DibBat,f  ;     ,   
	GOTO perev
	NOP	


;            
	MOVF SLR8,w
	MOVWF DibBat   ;   DibBat

	RETURN
;---------------------------------------------------------------------------------
BATROZR
	BSF   GPIO,5
	CALL DELAY_250
	BCF   GPIO,5
	CALL DELAY_250
	BSF   GPIO,5
	CALL DELAY_250
	BCF   GPIO,5
	CALL DELAY_250
	BSF   GPIO,5
	CALL DELAY_250
	BCF   GPIO,5
	CALL DELAY_250
	RETURN
;---------------------------------------------------------------------------------
Zatr250mks    ;  250
  		   movlw       .78
            movwf       SLR1
            decfsz      SLR1,F
            goto        $-1
            return

;---------------------------------------------------------------------------------
Zatr100mks    ;  100
  		   movlw       .31
            movwf       SLR1
            decfsz      SLR1,F
            goto        $-1
            return
;----------------------------------------------------------------------------------	
DELAY_005                            ; 5
            movlw       .125
            movwf       Reg_1
            movlw       .7
            movwf       Reg_2
            decfsz      Reg_1,F
            goto        $-1
            decfsz      Reg_2,F
            goto        $-3
            return

;-------------------------------------------------------------------------------
DELAY_250           ; 250
            movlw       .169
            movwf       Reg_1
            movlw       .69
            movwf       Reg_2
            movlw       .2
            movwf       Reg_3
           decfsz      Reg_1,F
            goto        $-1
            decfsz      Reg_2,F
            goto        $-3
            decfsz      Reg_3,F
            goto        $-5
           nop
           nop
           return

;---------------------------------------------------------------------------------------------------
READ_MEM
       bsf        STATUS, RP0          ;   1
       movwf   EEADR 
       bsf        EECON1, RD            ; 
       movfw     EEDATA                ;     W
       bcf        STATUS, RP0          ;   0 
       return
;------------------------------------------------------------------------------




	END                       ; directive 'end of program'

